Debian Bug report logs - #601974
regression: grub-probe can not find /dev/xvda1 (block device inside XEN)

version graph

Package: grub-common; Maintainer for grub-common is GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>; Source for grub-common is src:grub2.

Reported by: Csillag Kristof <csillag.kristof@gmail.com>

Date: Sun, 31 Oct 2010 13:45:01 UTC

Severity: important

Tags: fixed-upstream

Merged with 612874

Found in versions grub2/1.98+20100804-14, grub2/1.98+20100804-7

Fixed in version 1.99-1

Done: Robert Millan <rmh@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>:
Bug#601974; Package grub-common. (Sun, 31 Oct 2010 13:45:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Csillag Kristof <csillag.kristof@gmail.com>:
New Bug report received and forwarded. Copy sent to GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>. (Sun, 31 Oct 2010 13:45:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Csillag Kristof <csillag.kristof@gmail.com>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: regression: grub-probe can not find /dev/xvda1 (block device inside XEN)
Date: Sun, 31 Oct 2010 14:40:00 +0100
Package: grub-common
Version: 1.98+20100804-7
Severity: important

Hi, I am running a bunch of XEN virtual domains,
in which I have grub installed.
(I use pygrub to boot them from dom0, but that's irrelevant now.)

In the xen configuration, I have different block devices assigned for 
the partitions, like this:

disk = [ 
        'phy:safe2/intranet,hda1,w',
        'phy:safe2/intranet_swap,hda2,w',
]

So, in the virtual domain, the block devices appear like this;

real /dev/safe2/intranet       -> virtual /dev/xvda1
real /dev/safe2/intranet_swap  -> virtual /dev/xvda2 

Note there is no /dev/xvda device as such.

This works all right for normal disk IO.

In the grub config, I have

	root		(hd0)
	kernel 	....	root=/dev/xvda1

With grub-common from stable, I can make grub work
by manually creating a (fake) xvda device: mknod /dev/xvda b 202 0

devices.map looks like this:

	(hd0)	/dev/xvda


after this, update-grub works properly.

Now if I upgrade to grub-common from unstable, this starts to fail.
Whatever I do, it won't work.

How do I fix that?

Thank you for your help:

    Kristof Csillag


-- System Information:
Debian Release: 5.0.6
  APT prefers stable
  APT policy: (990, 'stable'), (500, 'unstable')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.32-5-amd64 (SMP w/2 CPU cores)
Locale: LANG=en_US.ISO-8859-15, LC_CTYPE=en_US.ISO-8859-15 (charmap=UTF-8) (ignored: LC_ALL set to hu_HU.UTF-8)
Shell: /bin/sh linked to /bin/bash

Versions of packages grub-common depends on:
ii  base-files             5lenny7           Debian base system miscellaneous f
ii  dpkg                   1.14.29+b1        Debian package management system
ii  gettext-base           0.17-4            GNU Internationalization utilities
ii  install-info           4.13a.dfsg.1-6    Manage installed documentation in 
ii  libc6                  2.11.2-6          Embedded GNU C Library: Shared lib
ii  libdevmapper1.02.1     2:1.02.48-3       The Linux Kernel Device Mapper use
ii  libfreetype6           2.3.7-2+lenny4    FreeType 2 font engine, shared lib
ii  zlib1g                 1:1.2.3.3.dfsg-12 compression library - runtime

Versions of packages grub-common recommends:
pn  os-prober                     <none>     (no description available)

Versions of packages grub-common suggests:
pn  grub-emu                      <none>     (no description available)
pn  multiboot-doc                 <none>     (no description available)
pn  xorriso                       <none>     (no description available)

-- no debconf information




Information forwarded to debian-bugs-dist@lists.debian.org, GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>:
Bug#601974; Package grub-common. (Mon, 01 Nov 2010 12:30:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Vladimir 'φ-coder/phcoder' Serbinenko <phcoder@gmail.com>:
Extra info received and forwarded to list. Copy sent to GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>. (Mon, 01 Nov 2010 12:30:05 GMT) Full text and rfc822 format available.

Message #10 received at 601974@bugs.debian.org (full text, mbox):

From: Vladimir 'φ-coder/phcoder' Serbinenko <phcoder@gmail.com>
To: Csillag Kristof <csillag.kristof@gmail.com>, 601974@bugs.debian.org
Cc: control@bugs.debian.org
Subject: Re: Bug#601974: regression: grub-probe can not find /dev/xvda1 (block device inside XEN)
Date: Mon, 01 Nov 2010 13:28:05 +0100
[Message part 1 (text/plain, inline)]
tag 601974 need-info
thanks

> Now if I upgrade to grub-common from unstable, this starts to fail.
> Whatever I do, it won't work.
>
> How do I fix that?
>
>   
Can you post the actual error messages (with -v) and tell what you
actually tried rather than a very vague paraphrase.

-- 
Regards
Vladimir 'φ-coder/phcoder' Serbinenko


[signature.asc (application/pgp-signature, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>:
Bug#601974; Package grub-common. (Mon, 01 Nov 2010 15:12:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Csillag Kristof <csillag.kristof@gmail.com>:
Extra info received and forwarded to list. Copy sent to GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>. (Mon, 01 Nov 2010 15:12:06 GMT) Full text and rfc822 format available.

Message #15 received at 601974@bugs.debian.org (full text, mbox):

From: Csillag Kristof <csillag.kristof@gmail.com>
To: 601974@bugs.debian.org
Cc: Vladimir 'φ-coder/phcoder' Serbinenko <phcoder@gmail.com>
Subject: Re: Bug#601974: regression: grub-probe can not find /dev/xvda1 (block device inside XEN)
Date: Mon, 01 Nov 2010 16:01:09 +0100
2010-11-01 13:28 keltezéssel, Vladimir 'φ-coder/phcoder' Serbinenko írta:
> tag 601974 need-info
> thanks
>
>   
>> Now if I upgrade to grub-common from unstable, this starts to fail.
>> Whatever I do, it won't work.
>>
>> How do I fix that?
>>
>>   
>>     
> Can you post the actual error messages (with -v)

With old grub-common:

#update-grub -v
Searching for GRUB installation directory ... found: /boot/grub
Searching for default file ... found: /boot/grub/default
Testing for an existing GRUB menu.lst file ... found: /boot/grub/menu.lst
Searching for splash image ... none found, skipping ...
Found kernel: /boot/vmlinuz-2.6.32-5-amd64
Updating /boot/grub/menu.lst ... done

with new grub-common:

# update-grub -v
Searching for GRUB installation directory ... found: /boot/grub
warning: grub-probe can't find drive for /dev/xvda1.
grub-probe: error: cannot find a GRUB drive for /dev/xvda1.  Check your
device.map.

Replacing grup-probe with a wrapper script, I can see that update-grub
is calling grub-probe several times, with the following parameters:

--device-map=/boot/grub/device.map -t device /
--device-map=/boot/grub/device.map -t device /boot
-t abstraction --device /dev/xvda1
--device-map=/boot/grub/device.map -t drive -d /dev/xvda1
--device-map=/tmp/device.map.woTwrstX -t drive -d /dev/xvda1

It seems to me that the first call witch fails with the new grub (but
succeeds with the new one) is this:

grub-probe -t abstraction --device /dev/xvda1 -v

With old grub, this returns:

# grub-probe -t abstraction --device /dev/xvda1 -v
error: cannot open `/dev/xvda'
error: cannot open `/dev/xvda'
grub-probe: info: did not find LVM/RAID in /dev/xvda1, assuming raw device

With new grub, this returns:

# grub-probe -t abstraction --device /dev/xvda1 -v
grub-probe: info: /dev/xvda1 starts from 0.
grub-probe: info: opening the device hd0.
grub-probe: error: cannot find a GRUB drive for /dev/xvda1.  Check your
device.map.

As I have already shown, device.map contains this:

    (hd0)    /dev/xvda

so it might try to open /dev/xvda, which is a fake device, it does not
exist.
Only xvda1 and xvda2 exists.
Old grub could cope with this.


> and tell what you actually tried rather than a very vague paraphrase.
>   
I don't remember. Tried to get this work a few months ago, the failed
and dropped it. (Went back to old grub.) Now I am forced to upgrade,
because lvm updates. Tried again, still does not work. Thus, I report
the bug.

Please let me know how can I help you to debug this.

Best wishes:

    Csillag





Information forwarded to debian-bugs-dist@lists.debian.org, GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>:
Bug#601974; Package grub-common. (Mon, 01 Nov 2010 17:30:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Vladimir 'φ-coder/phcoder' Serbinenko <phcoder@gmail.com>:
Extra info received and forwarded to list. Copy sent to GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>. (Mon, 01 Nov 2010 17:30:02 GMT) Full text and rfc822 format available.

Message #20 received at 601974@bugs.debian.org (full text, mbox):

From: Vladimir 'φ-coder/phcoder' Serbinenko <phcoder@gmail.com>
To: Csillag Kristof <csillag.kristof@gmail.com>
Cc: 601974@bugs.debian.org
Subject: Re: Bug#601974: regression: grub-probe can not find /dev/xvda1 (block device inside XEN)
Date: Mon, 01 Nov 2010 18:26:25 +0100
[Message part 1 (text/plain, inline)]
On 11/01/2010 04:01 PM, Csillag Kristof wrote:
> 2010-11-01 13:28 keltezéssel, Vladimir 'φ-coder/phcoder' Serbinenko írta:
>   
>> tag 601974 need-info
>> thanks
>>
>>   
>>     
>>> Now if I upgrade to grub-common from unstable, this starts to fail.
>>> Whatever I do, it won't work.
>>>
>>> How do I fix that?
>>>
>>>   
>>>     
>>>       
>> Can you post the actual error messages (with -v)
>>     
> With old grub-common:
>
> #update-grub -v
> Searching for GRUB installation directory ... found: /boot/grub
> Searching for default file ... found: /boot/grub/default
> Testing for an existing GRUB menu.lst file ... found: /boot/grub/menu.lst
> Searching for splash image ... none found, skipping ...
> Found kernel: /boot/vmlinuz-2.6.32-5-amd64
> Updating /boot/grub/menu.lst ... done
>
> with new grub-common:
>
> # update-grub -v
> Searching for GRUB installation directory ... found: /boot/grub
> warning: grub-probe can't find drive for /dev/xvda1.
> grub-probe: error: cannot find a GRUB drive for /dev/xvda1.  Check your
> device.map.
>
> Replacing grup-probe with a wrapper script, I can see that update-grub
> is calling grub-probe several times, with the following parameters:
>
> --device-map=/boot/grub/device.map -t device /
> --device-map=/boot/grub/device.map -t device /boot
> -t abstraction --device /dev/xvda1
> --device-map=/boot/grub/device.map -t drive -d /dev/xvda1
> --device-map=/tmp/device.map.woTwrstX -t drive -d /dev/xvda1
>
> It seems to me that the first call witch fails with the new grub (but
> succeeds with the new one) is this:
>
> grub-probe -t abstraction --device /dev/xvda1 -v
>
> With old grub, this returns:
>
> # grub-probe -t abstraction --device /dev/xvda1 -v
> error: cannot open `/dev/xvda'
> error: cannot open `/dev/xvda'
> grub-probe: info: did not find LVM/RAID in /dev/xvda1, assuming raw device
>
> With new grub, this returns:
>
> # grub-probe -t abstraction --device /dev/xvda1 -v
> grub-probe: info: /dev/xvda1 starts from 0.
> grub-probe: info: opening the device hd0.
> grub-probe: error: cannot find a GRUB drive for /dev/xvda1.  Check your
> device.map.
>
> As I have already shown, device.map contains this:
>
>     (hd0)    /dev/xvda
>
> so it might try to open /dev/xvda, which is a fake device, it does not
> exist.
> Only xvda1 and xvda2 exists.
> Old grub could cope with this.
>
>
>   
Could you try removing this entry?
>> and tell what you actually tried rather than a very vague paraphrase.
>>   
>>     
> I don't remember. Tried to get this work a few months ago, the failed
> and dropped it. (Went back to old grub.) Now I am forced to upgrade,
> because lvm updates. Tried again, still does not work. Thus, I report
> the bug.
>
> Please let me know how can I help you to debug this.
>
> Best wishes:
>
>     Csillag
>
>
>   


-- 
Regards
Vladimir 'φ-coder/phcoder' Serbinenko


[signature.asc (application/pgp-signature, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>:
Bug#601974; Package grub-common. (Fri, 05 Nov 2010 07:24:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Csillag Kristof <csillag.kristof@gmail.com>:
Extra info received and forwarded to list. Copy sent to GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>. (Fri, 05 Nov 2010 07:24:03 GMT) Full text and rfc822 format available.

Message #25 received at 601974@bugs.debian.org (full text, mbox):

From: Csillag Kristof <csillag.kristof@gmail.com>
To: 601974@bugs.debian.org
Subject: Fwd: Re: Bug#601974: regression: grub-probe can not find /dev/xvda1 (block device inside XEN)
Date: Fri, 05 Nov 2010 08:19:11 +0100
[Message part 1 (text/plain, inline)]
I realized that I left this address out, so fwding..

-------- Eredeti üzenet --------
Tárgy: 	Re: Bug#601974: regression: grub-probe can not find /dev/xvda1
(block device inside XEN)
Dátum: 	Mon, 01 Nov 2010 23:30:50 +0100
Feladó: 	Csillag Kristof <csillag.kristof@gmail.com>
Címzett: 	Vladimir 'φ-coder/phcoder' Serbinenko <phcoder@gmail.com>



2010-11-01 18:26 keltezéssel, Vladimir 'φ-coder/phcoder' Serbinenko írta:
> [...]
>> With new grub, this returns:
>>
>> # grub-probe -t abstraction --device /dev/xvda1 -v
>> grub-probe: info: /dev/xvda1 starts from 0.
>> grub-probe: info: opening the device hd0.
>> grub-probe: error: cannot find a GRUB drive for /dev/xvda1.  Check your
>> device.map.
>>
>> As I have already shown, device.map contains this:
>>
>>     (hd0)    /dev/xvda
>>
>> so it might try to open /dev/xvda, which is a fake device, it does not
>> exist.
>> Only xvda1 and xvda2 exists.
>> Old grub could cope with this.
>>
>>
>>   
>>     
> Could you try removing this entry?
>   

With line from device.map removed:

# grub-probe -t abstraction --device /dev/xvda1 -v
grub-probe: info: /dev/xvda1 starts from 0.
grub-probe: info: opening the device /dev/xvda.
grub-probe: error: cannot find a GRUB drive for /dev/xvda1.  Check your
device.map.

The result is different, but still does not work.

I have also tried to remove the (fake) /dev/xvda device. The result is:

# grub-probe -t abstraction --device /dev/xvda1 -v
grub-probe: info: /dev/xvda1 starts from 0.
grub-probe: info: opening the device /dev/xvda.
grub-probe: error: cannot find a GRUB drive for /dev/xvda1.  Check your
device.map.

When testing with devices.map entry, but fake xvda removed:

# grub-probe -t abstraction --device /dev/xvda1 -v
grub-probe: info: Cannot stat `/dev/xvda', skipping.
grub-probe: info: /dev/xvda1 starts from 0.
grub-probe: info: opening the device /dev/xvda.
grub-probe: error: cannot find a GRUB drive for /dev/xvda1.  Check your
device.map.

    * * *

Anything else to test?

    Csillag


[Message part 2 (text/html, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>:
Bug#601974; Package grub-common. (Sat, 06 Nov 2010 22:48:08 GMT) Full text and rfc822 format available.

Acknowledgement sent to Vladimir 'φ-coder/phcoder' Serbinenko <phcoder@gmail.com>:
Extra info received and forwarded to list. Copy sent to GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>. (Sat, 06 Nov 2010 22:48:08 GMT) Full text and rfc822 format available.

Message #30 received at 601974@bugs.debian.org (full text, mbox):

From: Vladimir 'φ-coder/phcoder' Serbinenko <phcoder@gmail.com>
To: Csillag Kristof <csillag.kristof@gmail.com>, 601974@bugs.debian.org
Subject: Re: Bug#601974: regression: grub-probe can not find /dev/xvda1 (block device inside XEN)
Date: Sat, 06 Nov 2010 23:46:43 +0100
[Message part 1 (text/plain, inline)]
On 11/01/2010 11:30 PM, Csillag Kristof wrote:
> 2010-11-01 18:26 keltezéssel, Vladimir 'φ-coder/phcoder' Serbinenko írta:
>   
>> [...]
>>     
>>> With new grub, this returns:
>>>
>>> # grub-probe -t abstraction --device /dev/xvda1 -v
>>> grub-probe: info: /dev/xvda1 starts from 0.
>>> grub-probe: info: opening the device hd0.
>>> grub-probe: error: cannot find a GRUB drive for /dev/xvda1.  Check your
>>> device.map.
>>>
>>> As I have already shown, device.map contains this:
>>>
>>>     (hd0)    /dev/xvda
>>>
>>> so it might try to open /dev/xvda, which is a fake device, it does not
>>> exist.
>>> Only xvda1 and xvda2 exists.
>>> Old grub could cope with this.
>>>
>>>
>>>   
>>>     
>>>       
>> Could you try removing this entry?
>>   
>>     
> With line from device.map removed:
>
> # grub-probe -t abstraction --device /dev/xvda1 -v
> grub-probe: info: /dev/xvda1 starts from 0.
> grub-probe: info: opening the device /dev/xvda.
> grub-probe: error: cannot find a GRUB drive for /dev/xvda1.  Check your
> device.map.
>
> The result is different, but still does not work.
>
> I have also tried to remove the (fake) /dev/xvda device. The result is:
>
> # grub-probe -t abstraction --device /dev/xvda1 -v
> grub-probe: info: /dev/xvda1 starts from 0.
> grub-probe: info: opening the device /dev/xvda.
> grub-probe: error: cannot find a GRUB drive for /dev/xvda1.  Check your
> device.map.
>
> When testing with devices.map entry, but fake xvda removed:
>
> # grub-probe -t abstraction --device /dev/xvda1 -v
> grub-probe: info: Cannot stat `/dev/xvda', skipping.
> grub-probe: info: /dev/xvda1 starts from 0.
> grub-probe: info: opening the device /dev/xvda.
> grub-probe: error: cannot find a GRUB drive for /dev/xvda1.  Check your
> device.map.
>
>     * * *
>
> Anything else to test?
>   
The case with both device.map entry and fake device removed, this is the
correct way of doing it.
>     Csillag
>
>
>   


-- 
Regards
Vladimir 'φ-coder/phcoder' Serbinenko


[signature.asc (application/pgp-signature, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>:
Bug#601974; Package grub-common. (Tue, 09 Nov 2010 08:00:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Csillag Kristof <csillag.kristof@gmail.com>:
Extra info received and forwarded to list. Copy sent to GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>. (Tue, 09 Nov 2010 08:00:03 GMT) Full text and rfc822 format available.

Message #35 received at 601974@bugs.debian.org (full text, mbox):

From: Csillag Kristof <csillag.kristof@gmail.com>
To: Vladimir 'φ-coder/phcoder' Serbinenko <phcoder@gmail.com>
Cc: 601974@bugs.debian.org
Subject: Re: Bug#601974: regression: grub-probe can not find /dev/xvda1 (block device inside XEN)
Date: Tue, 09 Nov 2010 08:55:09 +0100
2010-11-06 23:46 keltezéssel, Vladimir 'φ-coder/phcoder' Serbinenko írta:
> The case with both device.map entry and fake device removed, this is the
> correct way of doing it.
>
>   
OK, so here is the suggested case again:

# grub-probe -t abstraction --device /dev/xvda1 -v
grub-probe: info: /dev/xvda1 starts from 0.
grub-probe: info: opening the device /dev/xvda.
grub-probe: error: cannot find a GRUB drive for /dev/xvda1.  Check your
device.map.

What to test next?

    Kristof





Information forwarded to debian-bugs-dist@lists.debian.org, GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>:
Bug#601974; Package grub-common. (Wed, 17 Nov 2010 09:48:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Vladimir 'φ-coder/phcoder' Serbinenko <phcoder@gmail.com>:
Extra info received and forwarded to list. Copy sent to GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>. (Wed, 17 Nov 2010 09:48:05 GMT) Full text and rfc822 format available.

Message #40 received at 601974@bugs.debian.org (full text, mbox):

From: Vladimir 'φ-coder/phcoder' Serbinenko <phcoder@gmail.com>
To: Csillag Kristof <csillag.kristof@gmail.com>
Cc: 601974@bugs.debian.org
Subject: Re: Bug#601974: regression: grub-probe can not find /dev/xvda1 (block device inside XEN)
Date: Wed, 17 Nov 2010 10:45:16 +0100
[Message part 1 (text/plain, inline)]
Please keep the bug CC'ed.
Please test the attached patch
On 11/01/2010 11:30 PM, Csillag Kristof wrote:
> 2010-11-01 18:26 keltezéssel, Vladimir 'φ-coder/phcoder' Serbinenko írta:
>   
>> [...]
>>     
>>> With new grub, this returns:
>>>
>>> # grub-probe -t abstraction --device /dev/xvda1 -v
>>> grub-probe: info: /dev/xvda1 starts from 0.
>>> grub-probe: info: opening the device hd0.
>>> grub-probe: error: cannot find a GRUB drive for /dev/xvda1.  Check your
>>> device.map.
>>>
>>> As I have already shown, device.map contains this:
>>>
>>>     (hd0)    /dev/xvda
>>>
>>> so it might try to open /dev/xvda, which is a fake device, it does not
>>> exist.
>>> Only xvda1 and xvda2 exists.
>>> Old grub could cope with this.
>>>
>>>
>>>   
>>>     
>>>       
>> Could you try removing this entry?
>>   
>>     
> With line from device.map removed:
>
> # grub-probe -t abstraction --device /dev/xvda1 -v
> grub-probe: info: /dev/xvda1 starts from 0.
> grub-probe: info: opening the device /dev/xvda.
> grub-probe: error: cannot find a GRUB drive for /dev/xvda1.  Check your
> device.map.
>
> The result is different, but still does not work.
>
> I have also tried to remove the (fake) /dev/xvda device. The result is:
>
> # grub-probe -t abstraction --device /dev/xvda1 -v
> grub-probe: info: /dev/xvda1 starts from 0.
> grub-probe: info: opening the device /dev/xvda.
> grub-probe: error: cannot find a GRUB drive for /dev/xvda1.  Check your
> device.map.
>
> When testing with devices.map entry, but fake xvda removed:
>
> # grub-probe -t abstraction --device /dev/xvda1 -v
> grub-probe: info: Cannot stat `/dev/xvda', skipping.
> grub-probe: info: /dev/xvda1 starts from 0.
> grub-probe: info: opening the device /dev/xvda.
> grub-probe: error: cannot find a GRUB drive for /dev/xvda1.  Check your
> device.map.
>
>     * * *
>
> Anything else to test?
>
>     Csillag
>
>
>   


-- 
Regards
Vladimir 'φ-coder/phcoder' Serbinenko

[hostdisk.diff (text/x-diff, attachment)]
[signature.asc (application/pgp-signature, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>:
Bug#601974; Package grub-common. (Wed, 17 Nov 2010 14:18:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Csillag Kristof <csillag.kristof@gmail.com>:
Extra info received and forwarded to list. Copy sent to GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>. (Wed, 17 Nov 2010 14:18:03 GMT) Full text and rfc822 format available.

Message #45 received at 601974@bugs.debian.org (full text, mbox):

From: Csillag Kristof <csillag.kristof@gmail.com>
To: Vladimir 'φ-coder/phcoder' Serbinenko <phcoder@gmail.com>
Cc: 601974@bugs.debian.org
Subject: Re: Bug#601974: regression: grub-probe can not find /dev/xvda1 (block device inside XEN)
Date: Wed, 17 Nov 2010 15:14:16 +0100
2010-11-17 10:45 keltezéssel, Vladimir 'φ-coder/phcoder' Serbinenko írta:
> Please keep the bug CC'ed.
> Please test the attached patch
>   

Tried to apply patch to the version in debian unstable.
Got this:

~/grub2-1.98+20100804# patch --dry-run -p1 < /tmp/hostdisk.diff
patching file kern/emu/hostdisk.c
Hunk #1 FAILED at 1533.
1 out of 1 hunk FAILED -- saving rejects to file kern/emu/hostdisk.c.rej


What codebase am I supposed to apply this patch to?

Thank you:

   Kristof




Information forwarded to debian-bugs-dist@lists.debian.org, GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>:
Bug#601974; Package grub-common. (Wed, 17 Nov 2010 15:03:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Vladimir 'φ-coder/phcoder' Serbinenko <phcoder@gmail.com>:
Extra info received and forwarded to list. Copy sent to GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>. (Wed, 17 Nov 2010 15:03:03 GMT) Full text and rfc822 format available.

Message #50 received at 601974@bugs.debian.org (full text, mbox):

From: Vladimir 'φ-coder/phcoder' Serbinenko <phcoder@gmail.com>
To: Csillag Kristof <csillag.kristof@gmail.com>
Cc: 601974@bugs.debian.org
Subject: Re: Bug#601974: regression: grub-probe can not find /dev/xvda1 (block device inside XEN)
Date: Wed, 17 Nov 2010 16:01:05 +0100
[Message part 1 (text/plain, inline)]
On 11/17/2010 03:14 PM, Csillag Kristof wrote:
> 2010-11-17 10:45 keltezéssel, Vladimir 'φ-coder/phcoder' Serbinenko írta:
>   
>> Please keep the bug CC'ed.
>> Please test the attached patch
>>   
>>     
> Tried to apply patch to the version in debian unstable.
> Got this:
>
> ~/grub2-1.98+20100804# patch --dry-run -p1 < /tmp/hostdisk.diff
>   
-p0, not p1
> patching file kern/emu/hostdisk.c
> Hunk #1 FAILED at 1533.
> 1 out of 1 hunk FAILED -- saving rejects to file kern/emu/hostdisk.c.rej
>
>
> What codebase am I supposed to apply this patch to?
>
> Thank you:
>
>    Kristof
>
>   


-- 
Regards
Vladimir 'φ-coder/phcoder' Serbinenko


[signature.asc (application/pgp-signature, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>:
Bug#601974; Package grub-common. (Wed, 17 Nov 2010 15:21:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Csillag Kristof <csillag.kristof@gmail.com>:
Extra info received and forwarded to list. Copy sent to GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>. (Wed, 17 Nov 2010 15:21:05 GMT) Full text and rfc822 format available.

Message #55 received at 601974@bugs.debian.org (full text, mbox):

From: Csillag Kristof <csillag.kristof@gmail.com>
To: Vladimir 'φ-coder/phcoder' Serbinenko <phcoder@gmail.com>
Cc: 601974@bugs.debian.org
Subject: Re: Bug#601974: regression: grub-probe can not find /dev/xvda1 (block device inside XEN)
Date: Wed, 17 Nov 2010 16:17:51 +0100
2010-11-17 16:01 keltezéssel, Vladimir 'φ-coder/phcoder' Serbinenko írta:
>
>> ~/grub2-1.98+20100804# patch --dry-run -p1 < /tmp/hostdisk.diff
>>   
>>     
> -p0, not p1
>   
I don't think that was the probme here.
-p1 finds the file (but fails), -p0 does not even find the file.
See this:
--------------------------------------------

intranet:~/grub2-1.98+20100804# file kern/emu/hostdisk.c
kern/emu/hostdisk.c: ASCII C program text
intranet:~/grub2-1.98+20100804# patch --dry-run -p0 < /tmp/hostdisk.diff
can't find file to patch at input line 4
Perhaps you used the wrong -p or --strip option?
The text leading up to this was:
--------------------------
|=== modified file 'grub-core/kern/emu/hostdisk.c'
|--- grub-core/kern/emu/hostdisk.c    2010-11-06 23:10:49 +0000
|+++ grub-core/kern/emu/hostdisk.c    2010-11-17 09:39:45 +0000
--------------------------
File to patch: ^C




Information forwarded to debian-bugs-dist@lists.debian.org, GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>:
Bug#601974; Package grub-common. (Wed, 17 Nov 2010 15:45:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Csillag Kristof <csillag.kristof@gmail.com>:
Extra info received and forwarded to list. Copy sent to GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>. (Wed, 17 Nov 2010 15:45:05 GMT) Full text and rfc822 format available.

Message #60 received at 601974@bugs.debian.org (full text, mbox):

From: Csillag Kristof <csillag.kristof@gmail.com>
To: Vladimir 'φ-coder/phcoder' Serbinenko <phcoder@gmail.com>
Cc: 601974@bugs.debian.org
Subject: Re: Bug#601974: regression: grub-probe can not find /dev/xvda1 (block device inside XEN)
Date: Wed, 17 Nov 2010 16:42:47 +0100
2010-11-17 10:45 keltezéssel, Vladimir 'φ-coder/phcoder' Serbinenko írta:
> Please keep the bug CC'ed.
> Please test the attached patch
>   

After checking the contents of the patch, I see that the lines surrounding
the actual modifications do not exist in my local version
(which comes from latest Debian unstable, 1.98+20100804-8),
so I assume the patch was created against a newer version.

Which version, and where do I get it?

    Kristof




Information forwarded to debian-bugs-dist@lists.debian.org, GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>:
Bug#601974; Package grub-common. (Wed, 17 Nov 2010 16:09:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Vladimir 'φ-coder/phcoder' Serbinenko <phcoder@gmail.com>:
Extra info received and forwarded to list. Copy sent to GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>. (Wed, 17 Nov 2010 16:09:03 GMT) Full text and rfc822 format available.

Message #65 received at 601974@bugs.debian.org (full text, mbox):

From: Vladimir 'φ-coder/phcoder' Serbinenko <phcoder@gmail.com>
To: Csillag Kristof <csillag.kristof@gmail.com>
Cc: 601974@bugs.debian.org
Subject: Re: Bug#601974: regression: grub-probe can not find /dev/xvda1 (block device inside XEN)
Date: Wed, 17 Nov 2010 17:07:26 +0100
[Message part 1 (text/plain, inline)]
On 11/17/2010 04:42 PM, Csillag Kristof wrote:
> 2010-11-17 10:45 keltezéssel, Vladimir 'φ-coder/phcoder' Serbinenko írta:
>   
>> Please keep the bug CC'ed.
>> Please test the attached patch
>>   
>>     
> After checking the contents of the patch, I see that the lines surrounding
> the actual modifications do not exist in my local version
> (which comes from latest Debian unstable, 1.98+20100804-8),
> so I assume the patch was created against a newer version.
>
>   
Hmm looks like Debian lags behind more than I thought. The version in
question is upstream trunk available as bzr checkout from
http://bzr.savannah.gnu.org/r/grub/trunk/grub/
Perhaps it needs no patching at all. Could you test? If upstream works
it will be more of a question of propagating relevant upstream commit.
> Which version, and where do I get it?
>
>     Kristof
>
>   


-- 
Regards
Vladimir 'φ-coder/phcoder' Serbinenko


[signature.asc (application/pgp-signature, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>:
Bug#601974; Package grub-common. (Wed, 17 Nov 2010 16:33:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Csillag Kristof <csillag.kristof@gmail.com>:
Extra info received and forwarded to list. Copy sent to GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>. (Wed, 17 Nov 2010 16:33:03 GMT) Full text and rfc822 format available.

Message #70 received at 601974@bugs.debian.org (full text, mbox):

From: Csillag Kristof <csillag.kristof@gmail.com>
To: Vladimir 'φ-coder/phcoder' Serbinenko <phcoder@gmail.com>
Cc: 601974@bugs.debian.org
Subject: Re: Bug#601974: regression: grub-probe can not find /dev/xvda1 (block device inside XEN)
Date: Wed, 17 Nov 2010 17:28:43 +0100
2010-11-17 17:07 keltezéssel, Vladimir 'φ-coder/phcoder' Serbinenko írta:
>   
>   
> Hmm looks like Debian lags behind more than I thought. The version in
> question is upstream trunk available as bzr checkout from
> http://bzr.savannah.gnu.org/r/grub/trunk/grub/
> Perhaps it needs no patching at all. Could you test?

Because of various reasons, I am using grub-legacy, not grub2.
Again, for various reasons, I still need grub-common from grub2.

So, my current installation is:

grub-common 1.98+20100804
grub-legacy 0.97-63

As far as I understand, this is perfectly valid and supported combination,
so I have no intention to change this.

Now, the upstream source (which I have checked out with bzr) is not
Debianized,
and I am not familiar with the grub build system, so I am not able to build
and install grub-common only, without messing up my (somewhat fragile)
configuration.

So, the short answer is that no, I can not test the upstream source without
your help.  If you can help me get a Debianized version of it, than I
can do it.

Thank you.

     Kristof





Information forwarded to debian-bugs-dist@lists.debian.org, GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>:
Bug#601974; Package grub-common. (Wed, 17 Nov 2010 16:39:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Vladimir 'φ-coder/phcoder' Serbinenko <phcoder@gmail.com>:
Extra info received and forwarded to list. Copy sent to GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>. (Wed, 17 Nov 2010 16:39:03 GMT) Full text and rfc822 format available.

Message #75 received at 601974@bugs.debian.org (full text, mbox):

From: Vladimir 'φ-coder/phcoder' Serbinenko <phcoder@gmail.com>
To: Csillag Kristof <csillag.kristof@gmail.com>
Cc: 601974@bugs.debian.org
Subject: Re: Bug#601974: regression: grub-probe can not find /dev/xvda1 (block device inside XEN)
Date: Wed, 17 Nov 2010 17:37:24 +0100
[Message part 1 (text/plain, inline)]
On 11/17/2010 05:28 PM, Csillag Kristof wrote:
> 2010-11-17 17:07 keltezéssel, Vladimir 'φ-coder/phcoder' Serbinenko írta:
>   
>>   
>>   
>> Hmm looks like Debian lags behind more than I thought. The version in
>> question is upstream trunk available as bzr checkout from
>> http://bzr.savannah.gnu.org/r/grub/trunk/grub/
>> Perhaps it needs no patching at all. Could you test?
>>     
> Because of various reasons, I am using grub-legacy, not grub2.
> Again, for various reasons, I still need grub-common from grub2.
>
> So, my current installation is:
>
> grub-common 1.98+20100804
> grub-legacy 0.97-63
>
> As far as I understand, this is perfectly valid and supported combination,
> so I have no intention to change this.
>
> Now, the upstream source (which I have checked out with bzr) is not
> Debianized,
> and I am not familiar with the grub build system, so I am not able to build
> and install grub-common only, without messing up my (somewhat fragile)
> configuration.
>
> So, the short answer is that no, I can not test the upstream source without
> your help.  If you can help me get a Debianized version of it, than I
> can do it.
>   
You don't have to actually install it. You can test grub-probe without
installing:
bzr branch http://bzr.savannah.gnu.org/r/grub/trunk/grub/
cd grub
./autogen.sh
make
sudo ./grub-probe -t fs -v /
> Thank you.
>
>      Kristof
>
>
>   


-- 
Regards
Vladimir 'φ-coder/phcoder' Serbinenko


[signature.asc (application/pgp-signature, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>:
Bug#601974; Package grub-common. (Wed, 17 Nov 2010 17:15:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Csillag Kristof <csillag.kristof@gmail.com>:
Extra info received and forwarded to list. Copy sent to GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>. (Wed, 17 Nov 2010 17:15:06 GMT) Full text and rfc822 format available.

Message #80 received at 601974@bugs.debian.org (full text, mbox):

From: Csillag Kristof <csillag.kristof@gmail.com>
To: Vladimir 'φ-coder/phcoder' Serbinenko <phcoder@gmail.com>
Cc: 601974@bugs.debian.org
Subject: Re: Bug#601974: regression: grub-probe can not find /dev/xvda1 (block device inside XEN)
Date: Wed, 17 Nov 2010 18:11:59 +0100
2010-11-17 17:07 keltezéssel, Vladimir 'φ-coder/phcoder' Serbinenko írta:
>
> Hmm looks like Debian lags behind more than I thought. The version in
> question is upstream trunk available as bzr checkout from
> http://bzr.savannah.gnu.org/r/grub/trunk/grub/
> Perhaps it needs no patching at all. Could you test? If upstream works
> it will be more of a question of propagating relevant upstream commit.
>   

Compiling the trunk version was not smooth: it failed on a warning
because of compiler directives. Needed to override this manually.

Results:

intranet:~/g/grub# ./grub-probe  -t fs -v /
./grub-probe: info: changing current directory to /dev.
./grub-probe: info: changing current directory to story.
./grub-probe: info: changing current directory to snd.
./grub-probe: info: changing current directory to net.
./grub-probe: info: changing current directory to shm.
./grub-probe: info: changing current directory to network.
./grub-probe: info: changing current directory to pts.
./grub-probe: info: changing current directory to mapper.
./grub-probe: info: /dev/xvda1 starts from 0.
./grub-probe: info: opening the device /dev/xvda.
./grub-probe: warn: disk does not exist, so falling back to partition
device /dev/xvda1.
./grub-probe: info: opening /dev/xvda1.
./grub-probe: info: the size of /dev/xvda1 is 20971520.
ext2

So, yes, trunk version works.

Best wishes:

    Kristof




Information forwarded to debian-bugs-dist@lists.debian.org, GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>:
Bug#601974; Package grub-common. (Wed, 17 Nov 2010 17:27:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Vladimir 'φ-coder/phcoder' Serbinenko <phcoder@gmail.com>:
Extra info received and forwarded to list. Copy sent to GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>. (Wed, 17 Nov 2010 17:27:02 GMT) Full text and rfc822 format available.

Message #85 received at 601974@bugs.debian.org (full text, mbox):

From: Vladimir 'φ-coder/phcoder' Serbinenko <phcoder@gmail.com>
To: Csillag Kristof <csillag.kristof@gmail.com>
Cc: 601974@bugs.debian.org
Subject: Re: Bug#601974: regression: grub-probe can not find /dev/xvda1 (block device inside XEN)
Date: Wed, 17 Nov 2010 18:24:37 +0100
[Message part 1 (text/plain, inline)]
On 11/17/2010 06:11 PM, Csillag Kristof wrote:
> 2010-11-17 17:07 keltezéssel, Vladimir 'φ-coder/phcoder' Serbinenko írta:
>   
>> Hmm looks like Debian lags behind more than I thought. The version in
>> question is upstream trunk available as bzr checkout from
>> http://bzr.savannah.gnu.org/r/grub/trunk/grub/
>> Perhaps it needs no patching at all. Could you test? If upstream works
>> it will be more of a question of propagating relevant upstream commit.
>>   
>>     
> Compiling the trunk version was not smooth: it failed on a warning
> because of compiler directives. Needed to override this manually.
>
>   
What's the exact warning? I'd like to fix it.
> ./grub-probe: info: /dev/xvda1 starts from 0.
> ./grub-probe: info: opening the device /dev/xvda.
> ./grub-probe: warn: disk does not exist, so falling back to partition
> device /dev/xvda1.
> ./grub-probe: info: opening /dev/xvda1.
> ./grub-probe: info: the size of /dev/xvda1 is 20971520.
> ext2
>
> So, yes, trunk version works.
>
>   
Ok, I discarded the patch as useless then and pinged Colin Watson about
propagating needed commits.
> Best wishes:
>
>     Kristof
>
>   


-- 
Regards
Vladimir 'φ-coder/phcoder' Serbinenko


[signature.asc (application/pgp-signature, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>:
Bug#601974; Package grub-common. (Wed, 17 Nov 2010 17:33:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Csillag Kristof <csillag.kristof@gmail.com>:
Extra info received and forwarded to list. Copy sent to GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>. (Wed, 17 Nov 2010 17:33:03 GMT) Full text and rfc822 format available.

Message #90 received at 601974@bugs.debian.org (full text, mbox):

From: Csillag Kristof <csillag.kristof@gmail.com>
To: Vladimir 'φ-coder/phcoder' Serbinenko <phcoder@gmail.com>
Cc: 601974@bugs.debian.org
Subject: Re: Bug#601974: regression: grub-probe can not find /dev/xvda1 (block device inside XEN)
Date: Wed, 17 Nov 2010 18:30:06 +0100
2010-11-17 18:24 keltezéssel, Vladimir 'φ-coder/phcoder' Serbinenko írta:
>> Compiling the trunk version was not smooth: it failed on a warning
>> because of compiler directives. Needed to override this manually.
>>
>>   
>>     
> What's the exact warning? I'd like to fix it.
>   


When compiling grub-core/disk/mdraid1x_linux.c:

intranet:~/g/grub/grub-core# gcc -Werror -DHAVE_CONFIG_H -I. -I..  -Wall
-W -I../include -I../include  -DGRUB_MACHINE_PCBIOS=1
-DGRUB_MACHINE=I386_PC -nostdinc -isystem
/usr/lib/gcc/x86_64-linux-gnu/4.3.2/include
-DGRUB_FILE=\"disk/mdraid1x_linux.c\" -I. -I. -I.. -I.. -I../include
-I../include     -Os -Wall -W -Wshadow -Wpointer-arith
-Wmissing-prototypes -Wundef -Wstrict-prototypes -g -falign-jumps=1
-falign-loops=1 -falign-functions=1 -mno-mmx -mno-sse -mno-sse2
-mno-3dnow -m32 -fno-stack-protector -mno-stack-arg-probe
-DUSE_ASCII_FAILBACK=1 -DHAVE_UNIFONT_WIDTHSPEC=1  -mrtd
-mregparm=3       -ffreestanding   -MT
disk/mdraid1x_module-mdraid1x_linux.o -MD -MP -MF
disk/.deps-core/mdraid1x_module-mdraid1x_linux.Tpo -c -o
disk/mdraid1x_module-mdraid1x_linux.o `test -f 'disk/mdraid1x_linux.c'
|| echo './'`disk/mdraid1x_linux.c
cc1: warnings being treated as errors
disk/mdraid1x_linux.c: In function 'grub_mdraid_detect':
disk/mdraid1x_linux.c:108: error: 'sector' may be used uninitialized in
this function



Best wishes:

   Kristof




Information forwarded to debian-bugs-dist@lists.debian.org, GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>:
Bug#601974; Package grub-common. (Mon, 29 Nov 2010 12:33:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Csillag Kristof <csillag.kristof@gmail.com>:
Extra info received and forwarded to list. Copy sent to GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>. (Mon, 29 Nov 2010 12:33:03 GMT) Full text and rfc822 format available.

Message #95 received at 601974@bugs.debian.org (full text, mbox):

From: Csillag Kristof <csillag.kristof@gmail.com>
To: Vladimir 'φ-coder/phcoder' Serbinenko <phcoder@gmail.com>
Cc: 601974@bugs.debian.org
Subject: Re: Bug#601974: regression: grub-probe can not find /dev/xvda1 (block device inside XEN)
Date: Mon, 29 Nov 2010 13:27:15 +0100
2010-11-17 18:24 keltezéssel, Vladimir 'φ-coder/phcoder' Serbinenko írta:
> Ok, I discarded the patch as useless then and pinged Colin Watson about
> propagating needed commits.
>   

Hi,

Anything new about this?
(Version in unstable is still broken.)

>> Best wishes:
>>
>>     Kristof
>>     





Information forwarded to debian-bugs-dist@lists.debian.org, GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>:
Bug#601974; Package grub-common. (Sat, 18 Dec 2010 05:57:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to WindyWinter <windy@ream.at>:
Extra info received and forwarded to list. Copy sent to GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>. (Sat, 18 Dec 2010 05:57:03 GMT) Full text and rfc822 format available.

Message #100 received at 601974@bugs.debian.org (full text, mbox):

From: WindyWinter <windy@ream.at>
To: 601974@bugs.debian.org
Subject: Re: Bug#601974: regression: grub-probe can not find /dev/xvda1 (block device inside XEN)
Date: Sat, 18 Dec 2010 13:53:00 +0800
[Message part 1 (text/plain, inline)]
I got this problem in version 1.98+20100804-10 too.

Soli Deo gloria,
WindyWinter
Multi-Agent Systems Lab.,
University of Science and Technology of China
Email: windy@ream.at
梦.:如此短暂: http://d.ream.at
[Message part 2 (text/html, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>:
Bug#601974; Package grub-common. (Mon, 03 Jan 2011 18:48:13 GMT) Full text and rfc822 format available.

Acknowledgement sent to bd@bc-bd.org:
Extra info received and forwarded to list. Copy sent to GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>. (Mon, 03 Jan 2011 18:48:13 GMT) Full text and rfc822 format available.

Message #105 received at 601974@bugs.debian.org (full text, mbox):

From: bd@bc-bd.org
To: 601974@bugs.debian.org
Subject: works
Date: Mon, 3 Jan 2011 19:13:07 +0100
Hi,

I built grub-probe today, and it seems to work:

foo:~# /tmp/grub-probe --device /dev/xvda2
/tmp/grub-probe: warn: disk does not exist, so falling back to partition device
/dev/xvda2.
xfs
foo:~#

However, I have not tested with update-grub.

HTH

	Stefan
-- 
The abuse of greatness is when it disjoins remorse from power.
		-- William Shakespeare, "Julius Caesar"




Information forwarded to debian-bugs-dist@lists.debian.org, GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>:
Bug#601974; Package grub-common. (Wed, 26 Jan 2011 17:39:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Sebastian Cruz <default50@gmail.com>:
Extra info received and forwarded to list. Copy sent to GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>. (Wed, 26 Jan 2011 17:39:04 GMT) Full text and rfc822 format available.

Message #110 received at 601974@bugs.debian.org (full text, mbox):

From: Sebastian Cruz <default50@gmail.com>
To: Debian Bug Tracking System <601974@bugs.debian.org>
Subject: Re: grub-probe can not find /dev/xvda1 (block device inside XEN)
Date: Wed, 26 Jan 2011 14:31:48 -0300
Package: grub-pc
Severity: normal


I had the same issue on several DomUs over different Dom0s. I've just tried installing grub-pc and grub-common from unstable (1.98+20100804-14_amd64) and the problem persisted.

Right after that I installed both packages from experimental (1.99~rc1-1_amd64) and I could correctly install grub and update-grub works as expected, though it outputs lots of warnings.

For further reference:

# grub-probe --device /dev/xvda1
grub-probe: warn: disk does not exist, so falling back to partition device /dev/xvda1.
ext2
# echo $?
0
# update-grub
Generating grub.cfg ...
/usr/sbin/grub-probe: warn: disk does not exist, so falling back to partition device /dev/xvda1.
/usr/sbin/grub-probe: warn: disk does not exist, so falling back to partition device /dev/xvda1.
/usr/sbin/grub-probe: warn: disk does not exist, so falling back to partition device /dev/xvda1.
/usr/sbin/grub-probe: warn: disk does not exist, so falling back to partition device /dev/xvda1.
/usr/sbin/grub-probe: warn: disk does not exist, so falling back to partition device /dev/xvda1.
/usr/sbin/grub-probe: warn: disk does not exist, so falling back to partition device /dev/xvda1.
/usr/sbin/grub-probe: warn: disk does not exist, so falling back to partition device /dev/xvda1.
/usr/sbin/grub-probe: warn: disk does not exist, so falling back to partition device /dev/xvda1.
/usr/sbin/grub-probe: warn: disk does not exist, so falling back to partition device /dev/xvda1.
Found linux image: /boot/vmlinuz-2.6.32-5-xen-amd64
Found initrd image: /boot/initrd.img-2.6.32-5-xen-amd64
/usr/sbin/grub-probe: warn: disk does not exist, so falling back to partition device /dev/xvda1.
/usr/sbin/grub-probe: warn: disk does not exist, so falling back to partition device /dev/xvda1.
/usr/sbin/grub-probe: warn: disk does not exist, so falling back to partition device /dev/xvda1.
/usr/sbin/grub-probe: warn: disk does not exist, so falling back to partition device /dev/xvda1.
Found linux image: /boot/vmlinuz-2.6.32-5-amd64
Found initrd image: /boot/initrd.img-2.6.32-5-amd64
/usr/sbin/grub-probe: warn: disk does not exist, so falling back to partition device /dev/xvda1.
done

-- Package-specific info:

*********************** BEGIN /proc/mounts
/dev/xvda1 / ext4 rw,relatime,errors=remount-ro,barrier=1,data=ordered 0 0
/dev/xvda1 /home/ftp/gisworking/incoming/files ext4 rw,relatime,errors=remount-ro,barrier=1,data=ordered 0 0
/dev/xvda1 /home/ftp/gisworking/incoming/directories ext4 rw,relatime,errors=remount-ro,barrier=1,data=ordered 0 0
/dev/xvda1 /home/ftp/mdiraimondo/gisworking-kabul ext4 rw,relatime,errors=remount-ro,barrier=1,data=ordered 0 0
/dev/xvda1 /home/ftp/mdiraimondo/agcho ext4 rw,relatime,errors=remount-ro,barrier=1,data=ordered 0 0
/dev/xvda1 /home/ftp/mchomicki/gisworking-kabul ext4 rw,relatime,errors=remount-ro,barrier=1,data=ordered 0 0
/dev/xvda1 /home/ftp/mchomicki/agcho ext4 rw,relatime,errors=remount-ro,barrier=1,data=ordered 0 0
/dev/xvda1 /home/ftp/aprieto/xoomcode ext4 rw,relatime,errors=remount-ro,barrier=1,data=ordered 0 0
*********************** END /proc/mounts

*********************** BEGIN /boot/grub/device.map
*********************** END /boot/grub/device.map

*********************** BEGIN /boot/grub/grub.cfg
#
# DO NOT EDIT THIS FILE
#
# It is automatically generated by grub-mkconfig using templates
# from /etc/grub.d and settings from /etc/default/grub
#

### BEGIN /etc/grub.d/00_header ###
if [ -s $prefix/grubenv ]; then
  load_env
fi
set default="0"
if [ "${prev_saved_entry}" ]; then
  set saved_entry="${prev_saved_entry}"
  save_env saved_entry
  set prev_saved_entry=
  save_env prev_saved_entry
  set boot_once=true
fi

function savedefault {
  if [ -z "${boot_once}" ]; then
    saved_entry="${chosen}"
    save_env saved_entry
  fi
}

function load_video {
  insmod vbe
  insmod vga
  insmod video_bochs
  insmod video_cirrus
}

insmod ext2
set root='(/dev/xvda1)'
search --no-floppy --fs-uuid --set=root 75cbff23-c81d-44a2-b050-5010c3ebca86
if loadfont /usr/share/grub/unicode.pf2 ; then
  set gfxmode=640x480
  load_video
  insmod gfxterm
fi
terminal_output gfxterm
insmod ext2
set root='(/dev/xvda1)'
search --no-floppy --fs-uuid --set=root 75cbff23-c81d-44a2-b050-5010c3ebca86
set locale_dir=($root)/boot/grub/locale
set lang=en_US
insmod gettext
set timeout=5
### END /etc/grub.d/00_header ###

### BEGIN /etc/grub.d/05_debian_theme ###
set menu_color_normal=cyan/blue
set menu_color_highlight=white/blue
### END /etc/grub.d/05_debian_theme ###

### BEGIN /etc/grub.d/10_linux ###
menuentry 'Debian GNU/Linux, with Linux 2.6.32-5-xen-amd64' --class debian --class gnu-linux --class gnu --class os {
	insmod ext2
	set root='(/dev/xvda1)'
	search --no-floppy --fs-uuid --set=root 75cbff23-c81d-44a2-b050-5010c3ebca86
	echo	'Loading Linux 2.6.32-5-xen-amd64 ...'
	linux	/boot/vmlinuz-2.6.32-5-xen-amd64 root=UUID=75cbff23-c81d-44a2-b050-5010c3ebca86 ro  
	echo	'Loading initial ramdisk ...'
	initrd	/boot/initrd.img-2.6.32-5-xen-amd64
}
menuentry 'Debian GNU/Linux, with Linux 2.6.32-5-xen-amd64 (recovery mode)' --class debian --class gnu-linux --class gnu --class os {
	insmod ext2
	set root='(/dev/xvda1)'
	search --no-floppy --fs-uuid --set=root 75cbff23-c81d-44a2-b050-5010c3ebca86
	echo	'Loading Linux 2.6.32-5-xen-amd64 ...'
	linux	/boot/vmlinuz-2.6.32-5-xen-amd64 root=UUID=75cbff23-c81d-44a2-b050-5010c3ebca86 ro single 
	echo	'Loading initial ramdisk ...'
	initrd	/boot/initrd.img-2.6.32-5-xen-amd64
}
menuentry 'Debian GNU/Linux, with Linux 2.6.32-5-amd64' --class debian --class gnu-linux --class gnu --class os {
	insmod ext2
	set root='(/dev/xvda1)'
	search --no-floppy --fs-uuid --set=root 75cbff23-c81d-44a2-b050-5010c3ebca86
	echo	'Loading Linux 2.6.32-5-amd64 ...'
	linux	/boot/vmlinuz-2.6.32-5-amd64 root=UUID=75cbff23-c81d-44a2-b050-5010c3ebca86 ro  
	echo	'Loading initial ramdisk ...'
	initrd	/boot/initrd.img-2.6.32-5-amd64
}
menuentry 'Debian GNU/Linux, with Linux 2.6.32-5-amd64 (recovery mode)' --class debian --class gnu-linux --class gnu --class os {
	insmod ext2
	set root='(/dev/xvda1)'
	search --no-floppy --fs-uuid --set=root 75cbff23-c81d-44a2-b050-5010c3ebca86
	echo	'Loading Linux 2.6.32-5-amd64 ...'
	linux	/boot/vmlinuz-2.6.32-5-amd64 root=UUID=75cbff23-c81d-44a2-b050-5010c3ebca86 ro single 
	echo	'Loading initial ramdisk ...'
	initrd	/boot/initrd.img-2.6.32-5-amd64
}
### END /etc/grub.d/10_linux ###

### BEGIN /etc/grub.d/20_linux_xen ###
### END /etc/grub.d/20_linux_xen ###

### BEGIN /etc/grub.d/20_memtest86+ ###
### END /etc/grub.d/20_memtest86+ ###

### BEGIN /etc/grub.d/30_os-prober ###
### END /etc/grub.d/30_os-prober ###

### BEGIN /etc/grub.d/40_custom ###
# This file provides an easy way to add custom menu entries.  Simply type the
# menu entries you want to add after this comment.  Be careful not to change
# the 'exec tail' line above.
### END /etc/grub.d/40_custom ###

### BEGIN /etc/grub.d/41_custom ###
if [ -f  $prefix/custom.cfg ]; then
  source $prefix/custom.cfg;
fi
### END /etc/grub.d/41_custom ###
*********************** END /boot/grub/grub.cfg

-- System Information:
Debian Release: 6.0
  APT prefers testing
  APT policy: (500, 'testing')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.32-5-xen-amd64 (SMP w/2 CPU cores)
Locale: LANG=en_US.UTF-8, LC_CTYPE=en_US.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages grub-pc depends on:
ii  debconf [debconf-2.0]        1.5.36      Debian configuration management sy
ii  grub-common                  1.99~rc1-1  GRand Unified Bootloader, version 
ii  libc6                        2.11.2-9    Embedded GNU C Library: Shared lib
ii  libdevmapper1.02.1           2:1.02.48-4 The Linux Kernel Device Mapper use
ii  ucf                          3.0025+nmu1 Update Configuration File: preserv

grub-pc recommends no packages.

Versions of packages grub-pc suggests:
pn  desktop-base                  <none>     (no description available)

-- Configuration Files:
/etc/default/grub changed:
GRUB_DEFAULT=0
GRUB_TIMEOUT=5
GRUB_DISTRIBUTOR=`lsb_release -i -s 2> /dev/null || echo Debian`
GRUB_CMDLINE_LINUX_DEFAULT=""
GRUB_CMDLINE_LINUX=""


-- debconf information:
  grub2/kfreebsd_cmdline:
* grub2/device_map_regenerated:
  grub-pc/linux_cmdline: fillme
* grub2/linux_cmdline:
* grub-pc/install_devices_empty: true
* grub-pc/install_devices_failed: true
  grub-pc/chainload_from_menu.lst: true
  grub-pc/kopt_extracted: false
* grub-pc/install_devices:
  grub-pc/postrm_purge_boot_grub: false
  grub-pc/install_devices_failed_upgrade: true
  grub-pc/disk_description:
  grub2/kfreebsd_cmdline_default: quiet
  grub-pc/partition_description:
  grub-pc/install_devices_disks_changed:
* grub2/linux_cmdline_default:
  grub-pc/mixed_legacy_and_grub2: true




Information forwarded to debian-bugs-dist@lists.debian.org, GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>:
Bug#601974; Package grub-common. (Fri, 28 Jan 2011 07:57:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ian Campbell <ijc@hellion.org.uk>:
Extra info received and forwarded to list. Copy sent to GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>. (Fri, 28 Jan 2011 07:57:07 GMT) Full text and rfc822 format available.

Message #115 received at 601974@bugs.debian.org (full text, mbox):

From: Ian Campbell <ijc@hellion.org.uk>
To: Sebastian Cruz <default50@gmail.com>, 601974@bugs.debian.org
Subject: Re: Bug#601974: grub-probe can not find /dev/xvda1 (block device inside XEN)
Date: Fri, 28 Jan 2011 07:54:03 +0000
[Message part 1 (text/plain, inline)]
On Wed, 2011-01-26 at 14:31 -0300, Sebastian Cruz wrote: 
> Package: grub-pc
> Severity: normal
> 
> 
> I had the same issue on several DomUs over different Dom0s. I've just
> tried installing grub-pc and grub-common from unstable (1.98
> +20100804-14_amd64) and the problem persisted.
> 
> Right after that I installed both packages from experimental
> (1.99~rc1-1_amd64) and I could correctly install grub and update-grub
> works as expected, though it outputs lots of warnings.
> 
> For further reference:
> 
> # grub-probe --device /dev/xvda1
> grub-probe: warn: disk does not exist, so falling back to partition
> device /dev/xvda1. 
> ext2

Are you by any chance using the Xen configuration style where each
partition is a separate backend device? (as opposed to listing the whole
disk scheme which contains a partition table).

If you are then I think this is expected since you will find that you
really do only have /dev/xvda[1-N] but no /dev/xvda.

So long as you only care about using pygrub to boot your pv guests, as
opposed to switching to HVM mode and using proper-grub-pc from the MBR,
then I think the warning can simply be ignored.

Otherwise my recommendation would be to transition to the whole disk
scheme if this bothers you. Although the split partition scheme is not
deprecated by Xen as such it does tend to cause these sorts of knock-on
effects on other non-Xen aware parts of the system.

Ian.

-- 
Ian Campbell

"Everything should be made as simple as possible, but not simpler."
		-- Albert Einstein
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>:
Bug#601974; Package grub-common. (Thu, 24 Mar 2011 22:45:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to David North <david@dnorth.net>:
Extra info received and forwarded to list. Copy sent to GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>.

Your message did not contain a Subject field. They are recommended and useful because the title of a $gBug is determined using this field. Please remember to include a Subject field in your messages in future.

(Thu, 24 Mar 2011 22:45:03 GMT) Full text and rfc822 format available.


Message #120 received at 601974@bugs.debian.org (full text, mbox):

From: David North <david@dnorth.net>
To: 601974@bugs.debian.org
Date: Thu, 24 Mar 2011 22:08:56 +0000
Hi,

Has there been any progress on getting the fix for this backported? Now 
that squeeze has released, I've upgraded my Xen-based system to it and 
run into this problem with both grub-pc 1.98+20100804-14 and grub-legacy 
0.97-64.

Let me know if there's anything I can do to assist.

Cheers,
David




Forcibly Merged 601974 612874. Request was from Vladimir 'φ-coder/phcoder' Serbinenko <phcoder@gmail.com> to control@bugs.debian.org. (Tue, 29 Mar 2011 22:45:09 GMT) Full text and rfc822 format available.

Added tag(s) fixed-upstream. Request was from phcoder <phcoder@gmail.com> to control@bugs.debian.org. (Tue, 29 Mar 2011 22:54:04 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>:
Bug#601974; Package grub-common. (Wed, 25 May 2011 11:51:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Heywood Floyd <soul8o8@gmail.com>:
Extra info received and forwarded to list. Copy sent to GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>. (Wed, 25 May 2011 11:51:04 GMT) Full text and rfc822 format available.

Message #129 received at 601974@bugs.debian.org (full text, mbox):

From: Heywood Floyd <soul8o8@gmail.com>
To: 601974@bugs.debian.org
Subject: Bug persists, workaround
Date: Wed, 25 May 2011 13:49:30 +0200
Hello!

Have the same problem.
Running Debian Squeeze 64bit on a Xen VPS.
As follows, can't upgrade kernel with apt-get.


***

Workaround
Found the following steps to at least allow a kernel upgrade:
(Assuming grub-probe complains about /dev/xvda1)

Run:

	$ mknod /dev/xvdb b 202 0

(Assuming there's no already existing device named xvdb, xvdb1 or xvdb2 etc.)
Edit /boot/grub/devices.map to look like:

	(hd0)  /dev/xvdb

In /usr/sbin/grub-update find:

	find_device ()
	{
	        if ! test -e ${device_map} ; then
	                echo quit | grub --batch --no-floppy --device-map=${device_map} > /dev/null
	        fi
	        grub-probe --device-map=${device_map} -t device $1 2> /dev/null
	}

..and comment out one line and add one line as follows:

	find_device ()
	{
	        if ! test -e ${device_map} ; then
	                echo quit | grub --batch --no-floppy --device-map=${device_map} > /dev/null
	        fi
	        #grub-probe --device-map=${device_map} -t device $1 2> /dev/null
	        echo /dev/xvdb
	}

Then run:

	$ apt-get upgrade

..assuming this attempts to upgrade the kernel.
If successfull edit /boot/grub/menu.lst with:
	
	$ sed -i "s/xvdb/xvda1/g" /boot/grub/menu.lst

Perhaps also revert the edit in /usr/sbin/grup-update for good measure.
Reboot.
Worked for me.

(Workaround originally found at http://www.sysadmintalk.net/forums/Thread-PyGrub-grub-probe-can-t-find-drive-for-dev-xvda1-error-Debian-Squeeze , although that didn't work for me without some slight modifications, included above.)


BR
/HF



Information forwarded to debian-bugs-dist@lists.debian.org, GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>:
Bug#601974; Package grub-common. (Wed, 01 Jun 2011 17:48:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Claudius Peschke" <C.Peschke@gsi.de>:
Extra info received and forwarded to list. Copy sent to GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>. (Wed, 01 Jun 2011 17:48:06 GMT) Full text and rfc822 format available.

Message #134 received at 601974@bugs.debian.org (full text, mbox):

From: "Claudius Peschke" <C.Peschke@gsi.de>
To: <601974@bugs.debian.org>
Subject: Bug#601974: grub-probe can not find /dev/xvda1 (block device inside XEN)
Date: Wed, 01 Jun 2011 19:24:39 +0200
[Message part 1 (text/plain, inline)]
Hello,

to solve the problem for me, i have copied a few lines from grub2 version 1.99
to the old squeeze version 1.98+20100804-14 and applied the patch
(hostdisk.diff) from Vladimir 'φ-coder/phcoder' Serbinenko to it. With the
attached patch applied, the grub-probe command returns:

# grub-probe -t abstraction --device /dev/xvda1 -v
grub-probe: info: Cannot stat `/dev/xvda', skipping.
grub-probe: info: /dev/xvda1 starts from 0.
grub-probe: info: opening the device /dev/xvda.
grub-probe: warn: disk does not exist, so falling back to partition device
/dev/xvda1.
grub-probe: info: opening /dev/xvda1.
grub-probe: info: the size of /dev/xvda1 is 12582912.

and update-grub works without error.

[xen_raw_disk.patch (text/x-patch, attachment)]

Reply sent to Robert Millan <rmh@debian.org>:
You have taken responsibility. (Mon, 08 Aug 2011 18:33:06 GMT) Full text and rfc822 format available.

Notification sent to Csillag Kristof <csillag.kristof@gmail.com>:
Bug acknowledged by developer. (Mon, 08 Aug 2011 18:33:06 GMT) Full text and rfc822 format available.

Message #139 received at 601974-done@bugs.debian.org (full text, mbox):

From: Robert Millan <rmh@debian.org>
To: 601974-done@bugs.debian.org
Cc: Csillag Kristof <csillag.kristof@gmail.com>, WindyWinter <windy@ream.at>, bd@bc-bd.org, Sebastian Cruz <default50@gmail.com>, Ian Campbell <ijc@hellion.org.uk>, David North <david@dnorth.net>, Heywood Floyd <soul8o8@gmail.com>, Claudius Peschke <C.Peschke@gsi.de>
Subject: fixed in 1.99-1
Date: Mon, 8 Aug 2011 20:28:20 +0200
Version: 1.99-1

Hi,

According to upstream ChangeLog (and to source code in
grub-core/kern/emu/hostdisk.c), this problem was solved with GRUB 1.99
release.

-- 
Robert Millan




Reply sent to Robert Millan <rmh@debian.org>:
You have taken responsibility. (Mon, 08 Aug 2011 18:33:07 GMT) Full text and rfc822 format available.

Notification sent to Christian Motschke <motschke@itso-berlin.de>:
Bug acknowledged by developer. (Mon, 08 Aug 2011 18:33:07 GMT) Full text and rfc822 format available.

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Tue, 06 Sep 2011 07:39:50 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Fri Apr 18 06:18:06 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.